/* Jon Arney, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details */

#ifndef GNUT_HTTP_H
#define GNUT_HTTP_H

#define GNUT_HTTP_DEBUG      2
#define GNUT_HTTP_INTERNALS_DEBUG  3
#define HTTP_REQUEST_DEBUG    3
#define HTTP_HEADER_DEBUG    3
#define HTTP_IO_DEBUG      3

/*
 * This type definition
 * is meant for handling HTTP
 * requests to the Gnutella-net
 * network.
 */
typedef struct gnut_http_query_st {
  /*
   * Where did this req come from?
   */
  uchar   ip[4];
  uint16   port;
  char    guid[16];
  time_t  last_used;
  Gnut_List *query_list;
} gnut_http_query_t;


#include "http_core.h"
#include "http_header.h"

#ifdef __cplusplus
extern "C" {
#endif

  void fre_ghq(gnut_http_query_t **x, int bugnum);

/* Serve a share file. */
int gnut_http_serve_file(gnut_transfer *gt, http_request_t *req);

/* Get a list of GNUT files... */
int gnut_http_file_list(gnut_transfer *gt, http_request_t *req);

/* Provide a gateway into the GNUT
 * network. */
int gnut_http_file_search(gnut_transfer *gt, http_request_t *req);

/* Make a search form... */
int gnut_http_file_search_form(gnut_transfer *gt, http_request_t *req);

/* Call this when attempting to
 * find a query-er who requested this
 * result. */
int gnut_http_result_append(uchar ip[4], uchar port[2], int ref,
							int speed, int size, char *name,
							uchar guid[16]);

void gnut_http_write_top(http_request_t *req);
void gnut_http_write_bottom(http_request_t *req);
int gnut_http_write_form(http_request_t *req, int ttw, int rets);

void gnut_http_template_scan();

#ifdef __cplusplus
}
#endif

#endif
